import haxe.io.Path;

private enum LineStatus {
  Empty;
  Started;
  Continued;
}

class GeneratedFile {
  private var module(default, null): String;
  private var pack(default, null): String;
  private var pathSuffix(default, null): String;

  private var fragments(default, null): Array<String>;
  private var newline: String = "\n";
  private var lineStatus: LineStatus = Continued;

  public function new(moduleName: String) {
    var parts = moduleName.split(".");
    if (parts.length == 0) {
      throw "Module name can't be empty";
    }

    this.module = moduleName;
    var last = parts.pop();
    this.pack = parts.join(".");

    parts.push(last + ".hx");
    this.pathSuffix = Path.join(parts);

    this.fragments = [];
  }

  private function addNewline() {
    if (this.lineStatus.match(Empty))
      this.fragments[this.fragments.length - 1] = "\n";
    this.fragments.push(this.newline);
    this.lineStatus = Empty;
  }

  public function line(line: String = "") {
    this.addNewline();
    if (line.length != 0) {
      this.fragments.push(line);
      this.lineStatus = Started;
    }
  }

  public function push(fragment: String) {
    if (fragment.length != 0) {
      this.fragments.push(fragment);
      this.lineStatus = Continued;
    }
  }

  public function indent(?line: String) {
    if (line != null) {
      if (!this.lineStatus.match(Continued))
        this.addNewline();
      this.fragments.push(line);
    }

    this.newline += "  ";
    this.lineStatus = Started;
  }

  public inline function dedent(?line: String) {
    if (this.newline.length <= 2)
      throw "GeneratedFileError: too much dedent";
    
    this.newline = this.newline.substring(0, this.newline.length - 2);
    if (line != null) {
      this.addNewline();
      this.fragments.push(line);
      this.lineStatus = Started;
    }
  }

  public function writeToDisk(outDir: String): Void {
    var path = Path.join([outDir, this.pathSuffix]);
    sys.FileSystem.createDirectory(Path.directory(path));

    var out;
    try {
      out = sys.io.File.append(path, false);
    } catch (err: String) {
      // First time writing to file (it doesn't exist); create it and add header
      sys.FileSystem.createDirectory(Path.directory(path));
      out = sys.io.File.write(path, false);
      out.writeString('package ${this.pack};\n');
      out.writeString("// THIS FILE WAS AUTOGENERATED\n");
      out.writeString("// DO NOT EDIT MANUALLY\n");
    }

    for (fragment in this.fragments) {
      out.writeString(fragment);
    }

    out.writeString("\n");
    out.close();
  }
}